/***************************************************************/
/* Prof. Dr. Carsten Vogt                                      */
/* FH Koeln, Fak. 07 / Nachrichtentechnik                      */
/* http://www.nt.fh-koeln.de/vogt                              */
/*                                                             */
/* Das Programm demonstriert Basismethoden auf TreeMaps.       */
/* Mit TreeMaps werden Paare aus Schluesseln und Werten        */
/* verwaltet.                                                  */
/* Bei TreeMaps sind, im Unterschied zu HashMaps, die Eintrae- */
/* ge in aufsteigender Reihenfolge der Schluessel angeordnet.  */
/* Das Programm ist erst ab Java 5 lauffhig.                  */
/***************************************************************/

import java.io.*;
import java.util.*;

public class TreeMaps {

 public static void main(String[] args)  {

  /* Deklaration und Erzeugung einer TreeMap
     = nach Werten der Schluessel aufsteigend geordnete Folge
       von Paaren (Schluessel,Wert) */ 

  TreeMap<Integer,String> tab = new TreeMap<Integer,String>();

  System.out.println();
  System.out.println("Hinzufuegen von sechs Eintraegen:"); 
  System.out.println(" tab.put(3,\"Drei\")");
  System.out.println(" analog mit 1, 4, 2, 6, 5");
 
  tab.put(3, "Drei");
  tab.put(1, "Eins");
  tab.put(4, "Vier");
  tab.put(2, "Zwei");
  tab.put(6, "Sechs");
  tab.put(5, "Fuenf");

  /* Ueberpruefung, ob bestimmte Schluessel in der Tabelle sind  */

  System.out.println();
  System.out.println("tab.containsKey(2): "+tab.containsKey(2));
  System.out.println("tab.containsKey(9): "+tab.containsKey(9));

  /* Ueberpruefung, ob bestimmte Werte in der Tabelle sind  */

  System.out.println();
  System.out.println("tab.containsValue(\"Zwei\"): "+tab.containsValue("Zwei"));
  System.out.println("tab.containsValue(\"Neun\"): "+tab.containsValue("Neun"));

  /* Suche nach Werten anhand von Schluesseln */

  System.out.println();
  System.out.println("tab.get(2): "+tab.get(2));
  System.out.println("tab.get(6): "+tab.get(6));
  System.out.println("tab.get(9): "+tab.get(9));
  
  /* Ausgabe der Schluessel in der TreeMap */

  Collection menge = tab.keySet();

  System.out.println();
  System.out.println("tab.size(): "+tab.size());
  System.out.println();
  System.out.print("Schluessel in der TreeMap: ");
  for (Iterator it=menge.iterator();it.hasNext();)
   System.out.print(it.next()+" ");
  System.out.println();

  /* Ausgabe der Werte in der TreeMap */

  menge = tab.values();

  System.out.println();
  System.out.print("Werte in der TreeMap: ");
  for (Iterator it=menge.iterator();it.hasNext();)
   System.out.print(it.next()+" ");
  System.out.println();

  /* Entfernen von Elementen */

  System.out.println();
  System.out.println("Ausfuehrung von tab.remove(2)");
  tab.remove(2);
  System.out.println("Ausfuehrung von tab.remove(4)");
  tab.remove(4);

  menge = tab.values();

  System.out.println();
  System.out.print("Werte in der TreeMap: ");
  for (Iterator it=menge.iterator();it.hasNext();)
   System.out.print(it.next()+" ");
  System.out.println();

 }

}
