/***************************************************************/
/* Prof. Dr. Carsten Vogt                                      */
/* TH Koeln, Fakultaet IME                                     */
/* http://www.nt.th-koeln.de/vogt                              */
/*                                                             */
/* Das Programm demonstriert geschachtelte Methodenaufrufe.    */
/***************************************************************/

import java.io.*;

public class Geschachtelt {

  /* Die Methode 'betrag()' berechnet den Absolutwert (= Betrag) einer ganzen Zahl.
     Sie wird von der Methode 'abstand()' aufgerufen. */

  public static int betrag(int a) {
   int erg;
   if (a>=0)
     erg = a;
    else
     erg = -a;
   return erg; }
   
  /* Die Methode 'abstand()' berechnet den Abstand zweier ganzer Zahlen.
     Sie wird vom Hautptprogramm aufgerufen und ruft ihrerseits die Methode 'betrag()' auf. */

  public static int abstand(int a, int b) {
   int diff, erg;
   diff = a-b;
   erg = betrag(diff);
   return erg; }
   
  /* Das Hauptprogramm ruft die Methode 'abstand()' auf,
     die ihrerseits die Methode 'betrag()' aufruft. */
     
  public static void main(String args[]) throws IOException {
   int x, y, abst;
   BufferedReader in = new BufferedReader(new InputStreamReader(System.in));
   System.out.println("Bitte erste ganze Zahl eingeben: ");
   x = Integer.parseInt(in.readLine());
   System.out.println("Bitte zweite ganze Zahl eingeben: ");
   y = Integer.parseInt(in.readLine());
   abst = abstand(x,y);
   System.out.println("Der Abstand zwischen "+x+" und "+y+" betrgt "+abst);
  }
  
/* Programm in optimierter Fassung:
  
  public static int betrag(int a) {
   if (a>=0)
     return a;
    else
     return -a; }

  public static int abstand(int a, int b) {
   return betrag(a-b); }

  public static void main(String args[]) throws IOException {
   int x, y;
   BufferedReader in = new BufferedReader(new InputStreamReader(System.in));
   System.out.println("Bitte erste ganze Zahl eingeben: ");
   x = Integer.parseInt(in.readLine());
   System.out.println("Bitte zweite ganze Zahl eingeben: ");
   y = Integer.parseInt(in.readLine());
   System.out.println("Der Abstand zwischen "+x+" und "+y+" betrgt "+abstand(x,y));
  }

 */
}
