/***************************************************************/
/* Prof. Dr. Carsten Vogt                                      */
/* FH Koeln, Fak. 07 / Nachrichtentechnik                      */
/* http://www.nt.fh-koeln.de/vogt                              */
/*                                                             */
/* Das Programm zeigt am Beispiel von Bankkonten die Benutzung */
/* des Klassenkonzepts, insbesondere                           */
/* - Definition von Klassen mit klassen- und objektbezogenen   */
/*   Attributen / Methoden sowie oeffentlichen und privaten    */
/*   Attributen,                                               */
/* - Erzeugung und Loeschung von Objekten und                  */
/* - Vererbung mit Nutzung und Ueberschreiben von Methoden der */
/*   Superklasse.                                              */
/* Diese Datei enthaelt ein zeilenorientiertes Testprogramm;   */
/* die Klassendefinitionen stehen in den Dateien Konto.java    */
/* und GeschuetztesKonto.java.                                 */
/***************************************************************/

import java.io.*;

/*******************************************************

   Die Klasse 'KontoTest' ist ein zeilenorientiertes
   Testprogramm zur Arbeit mit den Klassen 'Konto'
   und 'GeschuetztesKonto'.
      
********************************************************/

public class KontoTest {

 public static void main(String args[]) throws IOException {

  BufferedReader in = new BufferedReader(new InputStreamReader(System.in));

  Konto konto1ungesch;

  GeschuetztesKonto konto2gesch;

  char dummy;

  double betr;

  int pi, spi;    

  /*********** Test von nicht geschuetzten Konten ***********/

  System.out.println();
  System.out.println("Eroeffnung eines nicht geschuetzten Kontos 'Konto 1'");
  System.out.println();
  System.out.print("Bitte gewuenschten Anfangsbetrag eingeben: ");
  betr = Double.parseDouble(in.readLine());
  konto1ungesch = new Konto(betr); 
  System.out.println();

  System.out.println("Anzahl existierender Konten: " + Konto.getAnzahlKonten());
  System.out.println("Kontostand von Konto 1:      " + konto1ungesch.abfragen());
  System.out.println();

  System.out.print("Einzahlen - bitte Betrag eingeben: ");
  betr = Double.parseDouble(in.readLine());
  konto1ungesch.einzahlen(betr);
  System.out.println("Kontostand von Konto 1:    " + konto1ungesch.abfragen());
  System.out.println();
  
  System.out.print("Abheben - bitte Betrag eingeben: ");
  betr = Double.parseDouble(in.readLine());
  if (konto1ungesch.abheben(betr)>=0.0)
    System.out.println("Abheben erfolgreich");
   else System.out.println("Abheben fehlgeschlagen");
  System.out.println("Kontostand von Konto 1:    " + konto1ungesch.abfragen());
  System.out.println();
 
  System.out.print("Nochmal abheben - bitte Betrag eingeben: ");
  betr = Double.parseDouble(in.readLine());
  if (konto1ungesch.abheben(betr)>=0.0)
    System.out.println("Abheben erfolgreich");
   else System.out.println("Abheben fehlgeschlagen");
  System.out.println("Kontostand von Konto 1:    " + konto1ungesch.abfragen());
  System.out.println();
 
  konto1ungesch = null;
  System.gc(); /* Garbage Collector, um Objekt tatsachlich zu loeschen */ 
  System.out.println("Anzahl existierender Konten: " + Konto.getAnzahlKonten());

  /*********** Test von geschuetzten Konten ***********/

  System.out.println();
  System.out.println("Eroeffnung eines geschuetzten Kontos 'Konto 2'");
  System.out.println();
  System.out.print("Bitte gewuenschten Anfangsbetrag eingeben: ");
  betr = Double.parseDouble(in.readLine());
  System.out.print("Bitte gewuenschte PIN eingeben: ");
  pi = Integer.parseInt(in.readLine());
  konto2gesch = new GeschuetztesKonto(betr,pi); 

  System.out.println();
  System.out.println("Anzahl existierender Konten: " + Konto.getAnzahlKonten());
  System.out.println("Kontostand von Konto 2:      " + konto2gesch.abfragen());
  System.out.println();

  System.out.print("Abheben - bitte Betrag eingeben: ");
  betr = Double.parseDouble(in.readLine());
  System.out.print("Bitte PIN eingeben: ");
  pi = Integer.parseInt(in.readLine());
  if (konto2gesch.abheben(betr,pi)>=0.0)
    System.out.println("Abheben erfolgreich");
   else System.out.println("Abheben fehlgeschlagen");
  System.out.println("Kontostand von Konto 2:    " + konto2gesch.abfragen());
  System.out.println();
 
  System.out.print("PIN aendern - bitte Super-PIN eingeben: ");
  spi = Integer.parseInt(in.readLine());
  System.out.print("Bitte gewuenschte neue PIN eingeben: ");
  pi = Integer.parseInt(in.readLine());
  if (konto2gesch.pinSetzen(spi,pi)==0)
    System.out.println("Aenderung erfolgreich");
   else System.out.println("Aenderung fehlgeschlagen");
  System.out.println();
 
  System.out.print("Abheben - bitte Betrag eingeben: ");
  betr = Double.parseDouble(in.readLine());
  System.out.print("Bitte PIN eingeben: ");
  pi = Integer.parseInt(in.readLine());
  if (konto2gesch.abheben(betr,pi)>=0.0)
    System.out.println("Abheben erfolgreich");
   else System.out.println("Abheben fehlgeschlagen");
  System.out.println("Kontostand von Konto 2:    " + konto2gesch.abfragen());
  System.out.println();

 }

}
