/****************************************************************/
/* Prof. Dr. Carsten Vogt                                       */
/* TH Koeln, Fakultaet IME                                      */
/* http://www.nt.th-koeln.de/vogt                               */
/*                                                              */
/* interrupt(), is Interrupted():                               */
/* Das Programm unterbricht einen laufenden Thread.             */
/****************************************************************/

import java.lang.Thread;

/* Klasse fuer Threads in diesem Beispiel */

class BeispielThread extends Thread {

 /* Ein BeispielThread gibt in einer Schleife einen Text wiederholt aus.
    Sobald von auen die Methode interrupt() aufgerufen wird,
    wird die Schleife verlassen. */

 public void run() {

   while (!isInterrupted()) {
    System.out.println("Hier ist der Thread");
   }

 }

}

public class Interrupt {

 public static void main(String[] args) {

  BeispielThread t = new BeispielThread();
  t.start();
  
  try {
    Thread.currentThread().sleep(2000);
  } catch (InterruptedException e) { }

  System.out.println(">>>>>>>>>> Main: Interrupt");
  t.interrupt();
  System.out.println(">>>>>>>>>> Main: Ende");

 }
}
