/****************************************************************/
/* Prof. Dr. Carsten Vogt                                       */
/* TH Koeln, Fakultaet IME                                      */
/* http://www.nt.th-koeln.de/vogt                               */
/*                                                              */
/* start(), run(), sleep():                                     */
/* Das Programm erzeugt zwei Threads, die jeweils eine bestimm- */
/* te Anzahl von Runden durchlaufen. Ein Thread gibt in jeder   */
/* Runde einen Text aus und "schlaeft" dann eine bestimmte An-  */
/* zahl von Millisekunden.                                      */
/****************************************************************/

/* Klasse fuer Threads in diesem Beispiel */

class BeispielThread extends Thread {

 /* Ein BeispielThread gibt dreimal hintereinander einen Text aus,
    wobei er zwischen zwei Ausgaben jeweils zwei Sekunden pausiert. */

 private String ausgabetext;

 /* Konstruktor: setzt den Ausgabetext */

 BeispielThread(String ausgabetext) {
  this.ausgabetext = ausgabetext;
 }

 /* Die Methode run() ueberschreibt die gleichnamige
    Methode der Basisklasse 'Thread'. Sie legt fest,
    welche Operationen der Thread waehrend seines
    "Lebens" ausfuehren soll. */

 public void run() {

   for (int i=0; i<3; i++) {
    try {
     sleep(1000);
    } catch (InterruptedException E) {  }
    System.out.println("Thread "+currentThread().getId()+": "+ausgabetext);
   }
   System.out.println("Thread "+currentThread().getId()+" ist fertig");

 }

} /* Ende von BeispielThread */


/* Klasse mit Hauptprogramm */

public class ThreadBasics {

 public static void main(String[] args) {

  /* Ausgabe der Nummer des Therads, der das Hauptprogramm ausfuehrt. */

  System.out.println();
  System.out.println("Hauptprogramm wird ausgefuehrt durch Thread "+Thread.currentThread().getId());

  /* Erzeugung zweier BeispielThreads */

  BeispielThread t1 = new BeispielThread("AAA");
  BeispielThread t2 = new BeispielThread("   BBB");

  System.out.println();

  /* Start der beiden Threads,
     die dann nebenlaeufig jeweils ihre run()-Methode ausfuehren. */

  t1.start();
  t2.start();

 }
}

// Erweiterte Version: Anzahl der Runden und Schlafzeiten variabel
//
///* Klasse fuer Threads in diesem Beispiel */
//
//class BeispielThread extends Thread {
//
// /* Ein BeispielThread durchlaeuft 'anzahlRunden'
//    Runden. In jeder Runde wartet er 'wartezeit'
//    Millisekunden und gibt dann den Text 'ausgabe-
//    Text' auf den Bildschirm aus. */
//
// private String ausgabeText;
// private int    wartezeit;
// private int    anzahlRunden;
//
// /* Konstruktor: setzt die Attributwerte */
//
// BeispielThread(String aus, int zeit, int anz) {
//  ausgabeText = aus;
//  wartezeit = zeit;
//  anzahlRunden = anz;
// }
//
// /* Die Methode run() ueberschreibt die gleichnamige
//    Methode der Basisklasse 'Thread'. Sie legt fest,
//    welche Operationen der Thread waehrend seines
//    "Lebens" ausfuehren soll. */
//
// public void run() {
//
//  try { /* try-catch ist wegen sleep() noetig */
//
//   for (int i=0; i<anzahlRunden; i++) {
//     sleep(wartezeit);
//     System.out.println("Thread "+currentThread().getId()+": "+ausgabeText);
//    }
//    System.out.println("Thread "+currentThread().getId()+" ist fertig");
//
//   } catch (InterruptedException E) {  }
//
// }
//
//} /* Ende von BeispielThread */
//
//
///* Klasse mit Hauptprogramm */
//
//public class ThreadBasics {
//
// public static void main(String[] args) {
//
//  /* Ausgabe der Threadnummer des Hauptprogramms */
//
//  System.out.println("Hauptprogramm wird ausgefuehrt durch Thread "+currentThread().getId());
//
//  /* Erzeugung zweier BeispielThreads */
//
//  BeispielThread t1 = new BeispielThread("AAA",2000,6);
//  BeispielThread t2 = new BeispielThread("   BBB",3000,4);
//
//  System.out.println();
//
//  /* Start der Threads,
//     die dann jeweils ihre run()-Methode ausfuehren */
//
//  t1.start();
//  t2.start();
//
// }
//
//}
